-- phpMyAdmin SQL Dump
-- version 3.5.8.1deb1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Jun 01, 2014 at 11:39 AM
-- Server version: 5.5.34-0ubuntu0.13.04.1
-- PHP Version: 5.4.9-4ubuntu2.4

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `profile`
--

-- --------------------------------------------------------

--
-- Table structure for table `ci_sessions`
--

CREATE TABLE IF NOT EXISTS `ci_sessions` (
  `unique_session_id` varchar(40) NOT NULL,
  `session_id` varchar(40) NOT NULL DEFAULT '0',
  `ip_address` varchar(45) NOT NULL DEFAULT '0',
  `user_agent` varchar(120) NOT NULL,
  `last_activity` int(10) unsigned NOT NULL DEFAULT '0',
  `user_data` text NOT NULL,
  PRIMARY KEY (`session_id`),
  KEY `last_activity_idx` (`last_activity`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `oauth_users`
--

CREATE TABLE IF NOT EXISTS `oauth_users` (
  `id_user` int(32) NOT NULL AUTO_INCREMENT,
  `username` varchar(255) NOT NULL,
  `password` varchar(2000) DEFAULT NULL,
  PRIMARY KEY (`id_user`),
  KEY `username` (`username`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Table structure for table `oauth_clients`
--

CREATE TABLE IF NOT EXISTS `oauth_clients` (
  `client_id` varchar(80) NOT NULL,
  `client_secret` varchar(80) NOT NULL,
  `redirect_uri` varchar(2000) NOT NULL,
  `requests_uri` varchar(2000) NOT NULL,
  `home_uri` varchar(2000) NOT NULL,
  `grant_types` varchar(80) DEFAULT NULL,
  `scope` varchar(100) DEFAULT NULL,
  `user_id` varchar(80) DEFAULT NULL,
  PRIMARY KEY (`client_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


-- --------------------------------------------------------

--
-- Table structure for table `oauth_access_tokens`
--

CREATE TABLE IF NOT EXISTS `oauth_access_tokens` (
  `access_token` varchar(40) NOT NULL,
  `client_id` varchar(80) NOT NULL,
  `user_id` int(32) DEFAULT NULL,
  `expires` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `scope` varchar(2000) DEFAULT NULL,
  `unique_session_id` varchar(40) NOT NULL,
  PRIMARY KEY (`access_token`),
  KEY (`client_id`),
  CONSTRAINT FOREIGN KEY (`client_id`) REFERENCES `oauth_clients`(`client_id`) ON DELETE CASCADE ON UPDATE CASCADE

 ) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `oauth_authorization_codes`
--

CREATE TABLE IF NOT EXISTS `oauth_authorization_codes` (
  `authorization_code` varchar(40) NOT NULL,
  `client_id` varchar(80) NOT NULL,
  `user_id` int(32) NOT NULL,
  `redirect_uri` varchar(2000) DEFAULT NULL,
  `expires` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `scope` varchar(2000) DEFAULT NULL,
  `unique_session_id` varchar(40) NOT NULL,
  KEY (`user_id`),
  KEY (`client_id`), 
  CONSTRAINT FOREIGN KEY(`user_id`) REFERENCES `oauth_users`(`id_user`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT FOREIGN KEY (`client_id`) REFERENCES `oauth_clients`(`client_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


-- --------------------------------------------------------

--
-- Table structure for table `oauth_jwt`
--

CREATE TABLE IF NOT EXISTS `oauth_jwt` (
  `client_id` varchar(80) NOT NULL,
  `subject` varchar(80) DEFAULT NULL,
  `public_key` varchar(2000) DEFAULT NULL,
  PRIMARY KEY (`client_id`),
  KEY (`client_id`),
  CONSTRAINT FOREIGN KEY (`client_id`) REFERENCES `oauth_clients`(`client_id`) ON DELETE CASCADE ON UPDATE CASCADE
 
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `oauth_refresh_tokens`
--

CREATE TABLE IF NOT EXISTS `oauth_refresh_tokens` (
  `refresh_token` varchar(40) NOT NULL,
  `client_id` varchar(80) NOT NULL,
  `user_id` int(32) DEFAULT NULL,
  `expires` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `scope` varchar(2000) DEFAULT NULL,
  `unique_session_id` varchar(40) NOT NULL,
  PRIMARY KEY (`refresh_token`),
   
 
  KEY (`client_id`), 
  CONSTRAINT FOREIGN KEY (`client_id`) REFERENCES `oauth_clients`(`client_id`) ON DELETE CASCADE ON UPDATE CASCADE

) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `oauth_scopes`
--

CREATE TABLE IF NOT EXISTS `oauth_scopes` (
  `scope` text,
  `is_default` tinyint(1) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `profile_achievement_types`
--

CREATE TABLE IF NOT EXISTS `profile_achievement_types` (
  `achievement_type` int(10) NOT NULL AUTO_INCREMENT,
  `achievement_title` varchar(100) COLLATE utf8_slovak_ci NOT NULL,
  `achievement_description` text CHARACTER SET utf32 COLLATE utf32_slovak_ci NOT NULL,
  `max` int(10) NOT NULL,
  `picture` varchar(50) CHARACTER SET latin1 NOT NULL,
  `value` int(10) NOT NULL,
  PRIMARY KEY (`achievement_type`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_slovak_ci AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Table structure for table `profile_activity_types`
--

CREATE TABLE IF NOT EXISTS `profile_activity_types` (
  `activity_type` int(10) NOT NULL AUTO_INCREMENT,
  `activity_title` varchar(100) COLLATE utf8_slovak_ci NOT NULL,
  `client_id` varchar(80) NOT NULL,
  PRIMARY KEY (`activity_type`),
  KEY (`client_id`), 
  CONSTRAINT FOREIGN KEY (`client_id`) REFERENCES `oauth_clients`(`client_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=0 ;




--
-- aaaTable structure for table `profile_achievements`
--

CREATE TABLE IF NOT EXISTS `profile_achievements` (
  `id_achievement` int(10) NOT NULL AUTO_INCREMENT,
  `id_user` int(32) NOT NULL,
  `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `source` varchar(100) CHARACTER SET latin1 NOT NULL,
  `achievement_type` int(10) NOT NULL,
  PRIMARY KEY `id_achievement` (`id_achievement`),
  KEY (`id_user`),
  KEY (`achievement_type`),
  FOREIGN KEY (`id_user`) REFERENCES `oauth_users`(`id_user`) ON DELETE CASCADE ON UPDATE CASCADE,
  FOREIGN KEY (`achievement_type`) REFERENCES `profile_achievement_types`(`achievement_type`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=0 ;




-- --------------------------------------------------------

--
-- Table structure for table `profile_activities`
--

CREATE TABLE IF NOT EXISTS `profile_activities` (
  `activity_type` int(10) NOT NULL,
  `id_user` int(32) NOT NULL,
  `id_activity` int(250) NOT NULL AUTO_INCREMENT,
  `activity` text COLLATE utf8_slovak_ci NOT NULL,
  `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id_activity`),
  KEY `id_activity` (`id_activity`),
  KEY (`id_user`),
  KEY (`activity_type`),
  FOREIGN KEY (`id_user`) REFERENCES `oauth_users`(`id_user`),
  FOREIGN KEY (`activity_type`) REFERENCES `profile_activity_types`(`activity_type`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Table structure for table `profile_badge_types`
--

CREATE TABLE IF NOT EXISTS `profile_badge_types` (
  `badge_type` int(10) NOT NULL AUTO_INCREMENT,
  `badge_title` varchar(100) COLLATE utf8_slovak_ci NOT NULL,
  `badge_description` text COLLATE utf8_slovak_ci NOT NULL,
  `picture` varchar(50) COLLATE utf8_slovak_ci NOT NULL,
  `value` int(10) NOT NULL,
  PRIMARY KEY (`badge_type`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=0 ;



-- --------------------------------------------------------

--
-- Table structure for table `profile_badges`
--

CREATE TABLE IF NOT EXISTS `profile_badges` (
  `id_user` int(32) NOT NULL,
  `id_user_who_gave_it` int(32) NOT NULL,
  `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `comment` text COLLATE utf8_slovak_ci NOT NULL,
  `id_badge` int(11) NOT NULL AUTO_INCREMENT,
  `badge_type` int(10) NOT NULL,
  PRIMARY KEY (`id_badge`),
  KEY `id_badge` (`id_user`,`id_user_who_gave_it`),
  KEY `id_user` (`id_user`),
  KEY `id_user_who_gave_it` (`id_user_who_gave_it`),
  KEY(`badge_type`),
  FOREIGN KEY (`id_user`) REFERENCES `oauth_users`(`id_user`),
  FOREIGN KEY (`id_user_who_gave_it`) REFERENCES `oauth_users`(`id_user`),
  FOREIGN KEY (`badge_type`) REFERENCES `profile_badge_types`(`badge_type`)

 
 


) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=0 ;


-- --------------------------------------------------------

--
-- Table structure for table `profile_general`
--

CREATE TABLE IF NOT EXISTS `profile_general` (
  `id_user` int(32) NOT NULL,
  `username` varchar(255) NOT NULL,
  `email` varchar(150) COLLATE utf8_slovak_ci NOT NULL,
  `first_name` varchar(50) CHARACTER SET utf8 NOT NULL,
  `surname` varchar(50) CHARACTER SET utf8 NOT NULL,
  `occupation` enum('student','teacher','other') COLLATE utf8_slovak_ci NOT NULL,
  `about_short` text COLLATE utf8_slovak_ci NOT NULL,
  `about_long` text COLLATE utf8_slovak_ci NOT NULL,
  `rating` float NOT NULL,
  `registration` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id_user`),
  KEY (`username`),
  FOREIGN KEY (`id_user`) REFERENCES `oauth_users`(`id_user`),
  FOREIGN KEY (`username`) REFERENCES `oauth_users`(`username`)
  
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=0 ;

-- --------------------------------------------------------

--
-- Table structure for table `profile_roles`
--

CREATE TABLE IF NOT EXISTS `profile_roles` (
  `id_user` int(32) NOT NULL,
  `role` int(2) NOT NULL,
   PRIMARY KEY (`id_user`),
   FOREIGN KEY (`id_user`) REFERENCES `oauth_users`(`id_user`)
  
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
